// GDIPlusHelper.h: interface for the CGDIPlusHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GDIPLUSHELPER_H__BD5F6266_5686_43E2_B146_5EA1217A56FE__INCLUDED_)
#define AFX_GDIPLUSHELPER_H__BD5F6266_5686_43E2_B146_5EA1217A56FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CAnimImage : public Image
{
public:
	CAnimImage(LPCTSTR sResourceType, LPCTSTR sResource);
	CAnimImage(const WCHAR* filename, BOOL useEmbeddedColorManagement = FALSE);
	
	~CAnimImage();

public:

	void			Draw(CDC* pDC);
	CSize			GetSize();

	BOOL			IsAnimatedGIF()									{ return m_nFrameCount > 1; }
	void			SetPause(BOOL bPause);
	BOOL			IsPaused()										{ return m_bPause; }
	BOOL			InitAnimation(HWND hWnd, CPoint pt);
	void			Destroy();

protected:
	BOOL			TestForAnimatedGIF();
	void			Initialize();
	BOOL			DrawFrameGIF();

	IStream*		m_pStream;
	
	BOOL			LoadFromBuffer(BYTE* pBuff, int nSize);
	BOOL			GetResource(LPCTSTR lpName, LPCTSTR lpType, void* pResource, int& nBufSize);
	BOOL			Load(CString sResourceType, CString sResource);

	void			ThreadAnimation();
	static UINT WINAPI _ThreadAnimationProc(LPVOID pParam);

	HANDLE			m_hThread;
	HANDLE			m_hPause;
	HANDLE			m_hExitEvent;
	HINSTANCE		m_hInst;
	HWND			m_hWnd;
	UINT			m_nFrameCount;
	UINT			m_nFramePosition;
	BOOL			m_bIsInitialized;
	BOOL			m_bPause;
	PropertyItem*	m_pPropertyItem;
	CPoint			m_pt;
};


#endif // !defined(AFX_GDIPLUSHELPER_H__BD5F6266_5686_43E2_B146_5EA1217A56FE__INCLUDED_)
